package net.pricefx.domain;

import com.fasterxml.jackson.annotation.JsonIgnore;

public abstract class NamedObject extends PartitionedObject {

	public static final String FIELD_UNIQUENAME = "uniqueName";
	public static final String FIELD_LABEL = "label";

	public NamedObject() {
	}

	public NamedObject(Partition partition, String uniqueName, String label) {
		super(partition);
		this.uniqueName = uniqueName;
		this.label = label;
	}

	private String uniqueName;

	private String label;

	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public String getUniqueName() {
		return uniqueName;
	}

	public void setUniqueName(String uniqueName) {
		this.uniqueName = uniqueName;
	}

	@JsonIgnore
	public String getLabelOrUniqueName() {
		return label == null ? uniqueName : label;
	}
	
	public String[] getSignificantFields() {
		return new String[] { FIELD_UNIQUENAME };
	}	


	public String toString(){
		return this.getUniqueName();
	}
	
}
