package net.pricefx.logic.core.model;

import java.util.Objects;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import net.pricefx.restapiclient.PfxClientException;

import static net.pricefx.restapiclient.PfxStatus.CODE_SUCCESS;


@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2017-11-10T15:30:45.019+01:00")
public class FormulaErrorElementResult extends FormulaElementResult {

  private Boolean error = null;
  @JsonIgnore
  private ElementPoint elementPoint = null;

  /**
   **/
  public FormulaErrorElementResult error(Boolean error) {
    this.error = error;
    return this;
  }
  
  @JsonProperty("error")
  public Boolean getError() {
    return error;
  }
  public void setError(Boolean error) {
    this.error = error;
    this.elementPoint = parseElementResult();
  }

  @JsonIgnore
  public boolean isError() {
    return error != null && error;
  }

  @JsonIgnore
  public ElementPoint getElementPoint() {
    return elementPoint;
  }

  public ElementPoint parseElementResult() {
    return isError() && elementResult instanceof String ? ElementPoint.parseElementResult((String) elementResult) : null;
  }

  public void raiseExceptionIfResultError() throws PfxClientException{
    if (error && elementResult instanceof String) {
      throw new PfxClientException(0, CODE_SUCCESS, (String) elementResult);
    }
  }
  

  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FormulaErrorElementResult formulaErrorElementResult = (FormulaErrorElementResult) o;
    return Objects.equals(this.elementName, formulaErrorElementResult.elementName) &&
        Objects.equals(this.elementLabel, formulaErrorElementResult.elementLabel) &&
        Objects.equals(this.elementResultDescription, formulaErrorElementResult.elementResultDescription) &&
        Objects.equals(this.traceMessages, formulaErrorElementResult.traceMessages) &&
        Objects.equals(this.alertMessage, formulaErrorElementResult.alertMessage) &&
        Objects.equals(this.warnings, formulaErrorElementResult.warnings) &&
        Objects.equals(this.alertType, formulaErrorElementResult.alertType) &&
        Objects.equals(this.displayOptions, formulaErrorElementResult.displayOptions) &&
        Objects.equals(this.formatType, formulaErrorElementResult.formatType) &&
        Objects.equals(this.overridden, formulaErrorElementResult.overridden) &&
        Objects.equals(this.overridable, formulaErrorElementResult.overridable) &&
        Objects.equals(this.summarize, formulaErrorElementResult.summarize) &&
        Objects.equals(this.hideOnNull, formulaErrorElementResult.hideOnNull) &&
        Objects.equals(this.hideWarnings, formulaErrorElementResult.hideWarnings) &&
        Objects.equals(this.userGroup, formulaErrorElementResult.userGroup) &&
        Objects.equals(this.resultGroup, formulaErrorElementResult.resultGroup) &&
        Objects.equals(this.labelTranslations, formulaErrorElementResult.labelTranslations) &&
        Objects.equals(this.suffix, formulaErrorElementResult.suffix) &&
        Objects.equals(this.cssProperties, formulaErrorElementResult.cssProperties) &&
        Objects.equals(this.cellStyles, formulaErrorElementResult.cellStyles) &&
        Objects.equals(this.overrideValueOptions, formulaErrorElementResult.overrideValueOptions) &&
        Objects.equals(this.overrideAllowEmpty, formulaErrorElementResult.overrideAllowEmpty) &&
        Objects.equals(this.resultType, formulaErrorElementResult.resultType) &&
        Objects.equals(this.fieldType, formulaErrorElementResult.fieldType) &&
        Objects.equals(this.elementResult, formulaErrorElementResult.elementResult) &&
        Objects.equals(this.error, formulaErrorElementResult.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(elementName, elementLabel, elementResultDescription, traceMessages, alertMessage, warnings, alertType, displayOptions, formatType, overridden, overridable, summarize, hideOnNull, hideWarnings, userGroup, resultGroup, labelTranslations, suffix, cssProperties, cellStyles, overrideValueOptions, overrideAllowEmpty, resultType, fieldType, elementResult, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FormulaErrorElementResult {\n");
    
    sb.append("    elementName: ").append(toIndentedString(elementName)).append("\n");
    sb.append("    elementLabel: ").append(toIndentedString(elementLabel)).append("\n");
    sb.append("    elementResultDescription: ").append(toIndentedString(elementResultDescription)).append("\n");
    sb.append("    traceMessages: ").append(toIndentedString(traceMessages)).append("\n");
    sb.append("    alertMessage: ").append(toIndentedString(alertMessage)).append("\n");
    sb.append("    warnings: ").append(toIndentedString(warnings)).append("\n");
    sb.append("    alertType: ").append(toIndentedString(alertType)).append("\n");
    sb.append("    displayOptions: ").append(toIndentedString(displayOptions)).append("\n");
    sb.append("    formatType: ").append(toIndentedString(formatType)).append("\n");
    sb.append("    overridden: ").append(toIndentedString(overridden)).append("\n");
    sb.append("    overridable: ").append(toIndentedString(overridable)).append("\n");
    sb.append("    summarize: ").append(toIndentedString(summarize)).append("\n");
    sb.append("    hideOnNull: ").append(toIndentedString(hideOnNull)).append("\n");
    sb.append("    hideWarnings: ").append(toIndentedString(hideWarnings)).append("\n");
    sb.append("    userGroup: ").append(toIndentedString(userGroup)).append("\n");
    sb.append("    resultGroup: ").append(toIndentedString(resultGroup)).append("\n");
    sb.append("    labelTranslations: ").append(toIndentedString(labelTranslations)).append("\n");
    sb.append("    suffix: ").append(toIndentedString(suffix)).append("\n");
    sb.append("    cssProperties: ").append(toIndentedString(cssProperties)).append("\n");
    sb.append("    cellStyles: ").append(toIndentedString(cellStyles)).append("\n");
    sb.append("    overrideValueOptions: ").append(toIndentedString(overrideValueOptions)).append("\n");
    sb.append("    overrideAllowEmpty: ").append(toIndentedString(overrideAllowEmpty)).append("\n");
    sb.append("    resultType: ").append(toIndentedString(resultType)).append("\n");
    sb.append("    fieldType: ").append(toIndentedString(fieldType)).append("\n");
    sb.append("    elementResult: ").append(toIndentedString(elementResult)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

}

